package com.ruoyi.common.pay.tm;

import com.alibaba.fastjson2.JSON;
import com.ruoyi.common.utils.http.HttpUtils;

import java.util.HashMap;

public class Application {

	private final static String HTTP = "https://pos.weixincore.com";
	private final static String SIGNKEY = "ac6d97e67b444b7a43edfc9182634786";

	public static void main(String[] args) {
		pay();
	}

	/**
	 * 订单查询
	 */
	public static void orderQuery() {
		HashMap<String, String> body = new HashMap<String, String>();
		body.put("tradeId", "1");
		body.put("terminalType", "1");
		body.put("shopId", "488");
		doPost("/open/Pay/orderQuery", body);
	}

	/**
	 * 退款
	 */
	public static void refund() {
		HashMap<String, String> body = new HashMap<String, String>();
		body.put("refundFee", "0.01");
		body.put("terminalType", "1");
		body.put("tradeId", "1");
		body.put("shopId", "488");
		doPost("/open/Pay/refund", body);
	}

	/**
	 * 付款码支付V2
	 */
	public static void microPayV2() {
		HashMap<String, String> body = new HashMap<String, String>();
		body.put("payAmount", "0.01");
		body.put("terminalType", "1");
		body.put("authCode", "3865199665693980");
		body.put("shopId", "488");
		doPost("/open/Pay/microPayV2", body);
	}

	/**
	 * jsapi支付
	 */
	public static void pay() {
		HashMap<String, String> body = new HashMap<String, String>();
		body.put("payAmount", "1");
		body.put("terminalType", "1");
		body.put("shopId", "488");
		// 填充必填字段
		body.put("sn", "deviceSN123456");    // 设备编号，需替换为真实设备号
		body.put("payType", "wx_pay");       // 支付方式，可以是 wx.pay, ali.pay, union.online
		body.put("outTradeId", "tradeId123");  // 商户订单号
		body.put("body", "商品描述");         // 商品描述
		body.put("notifyUrl", "https://yourdomain.com/notify"); // 异步回调URL
		body.put("frontUrl", "https://yourdomain.com/front");   // 前端页面跳转URL
		body.put("profitSharing", "N");      // 是否分账，示例填写 N
		doPost("/open/Pay/unifiedOrder", body);
	}

	private static void doPost(String url, HashMap<String, String> body) {
		body.put("developerId", "100001");
		body.put("version", "1.0");
		body.put("timestamp", String.valueOf(System.currentTimeMillis() / 1000));
		body.put("nonceStr", StringUtils.getRandomString(16));
		String bodyStr = StringUtils.getAsciiSort(body);
		String sign = Md5Utils.getMD5Code(bodyStr+"&key="+SIGNKEY).toUpperCase();
		body.put("sign", sign);

		HashMap<String, String> headerData = new HashMap<String, String>();
		headerData.put("Content-Type", "application/json");

		String response = HttpUtils.sendPostWithHeaders(HTTP + url, headerData,JSON.toJSONString(body));
		System.out.println("API Response: " + response);
	}

}
